diff --git a/lib/mbuf/rte_mbuf_dyn.h b/lib/mbuf/rte_mbuf_dyn.h
index 13f06d8ed25b..fb03cf1dcf90 100644
--- a/lib/mbuf/rte_mbuf_dyn.h
+++ b/lib/mbuf/rte_mbuf_dyn.h
@@ -118,7 +118,6 @@ struct rte_mbuf_dynflag {
  *   - ENOMEM: allocation failure.
  *   - ENAMETOOLONG: name does not ends with \0.
  */
-__rte_experimental
 int rte_mbuf_dynfield_register(const struct rte_mbuf_dynfield *params);
 
 /**
@@ -143,7 +142,6 @@ int rte_mbuf_dynfield_register(const struct rte_mbuf_dynfield *params);
  *   - ENOMEM: allocation failure.
  *   - ENAMETOOLONG: name does not ends with \0.
  */
-__rte_experimental
 int rte_mbuf_dynfield_register_offset(const struct rte_mbuf_dynfield *params,
 				size_t offset);
 
@@ -160,7 +158,6 @@ int rte_mbuf_dynfield_register_offset(const struct rte_mbuf_dynfield *params,
  *   Possible values for rte_errno:
  *   - ENOENT: no dynamic field matches this name.
  */
-__rte_experimental
 int rte_mbuf_dynfield_lookup(const char *name,
 			struct rte_mbuf_dynfield *params);
 
@@ -183,7 +180,6 @@ int rte_mbuf_dynfield_lookup(const char *name,
  *   - ENOMEM: allocation failure.
  *   - ENAMETOOLONG: name is longer than RTE_MBUF_DYN_NAMESIZE - 1.
  */
-__rte_experimental
 int rte_mbuf_dynflag_register(const struct rte_mbuf_dynflag *params);
 
 /**
@@ -208,7 +204,6 @@ int rte_mbuf_dynflag_register(const struct rte_mbuf_dynflag *params);
  *   - ENOMEM: allocation failure.
  *   - ENAMETOOLONG: name is longer than RTE_MBUF_DYN_NAMESIZE - 1.
  */
-__rte_experimental
 int rte_mbuf_dynflag_register_bitnum(const struct rte_mbuf_dynflag *params,
 				unsigned int bitnum);
 
@@ -225,7 +220,6 @@ int rte_mbuf_dynflag_register_bitnum(const struct rte_mbuf_dynflag *params,
  *   Possible values for rte_errno:
  *   - ENOENT: no dynamic flag matches this name.
  */
-__rte_experimental
 int rte_mbuf_dynflag_lookup(const char *name,
 			struct rte_mbuf_dynflag *params);
 
@@ -240,7 +234,6 @@ int rte_mbuf_dynflag_lookup(const char *name,
  * @param out
  *   The stream where the status is displayed.
  */
-__rte_experimental
 void rte_mbuf_dyn_dump(FILE *out);
 
 /*
@@ -277,9 +270,6 @@ typedef uint64_t rte_mbuf_timestamp_t;
 #define RTE_MBUF_DYNFLAG_RX_TIMESTAMP_NAME "rte_dynflag_rx_timestamp"
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice.
- *
  * Register dynamic mbuf field and flag for Rx timestamp.
  *
  * @param field_offset
@@ -295,7 +285,6 @@ typedef uint64_t rte_mbuf_timestamp_t;
  *   - ENOENT: no more field or flag available.
  *   - ENOMEM: allocation failure.
  */
-__rte_experimental
 int rte_mbuf_dyn_rx_timestamp_register(int *field_offset, uint64_t *rx_flag);
 
 /**
@@ -314,9 +303,6 @@ int rte_mbuf_dyn_rx_timestamp_register(int *field_offset, uint64_t *rx_flag);
 #define RTE_MBUF_DYNFLAG_TX_TIMESTAMP_NAME "rte_dynflag_tx_timestamp"
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice.
- *
  * Register dynamic mbuf field and flag for Tx timestamp.
  *
  * @param field_offset
@@ -332,7 +318,6 @@ int rte_mbuf_dyn_rx_timestamp_register(int *field_offset, uint64_t *rx_flag);
  *   - ENOENT: no more field or flag available.
  *   - ENOMEM: allocation failure.
  */
-__rte_experimental
 int rte_mbuf_dyn_tx_timestamp_register(int *field_offset, uint64_t *tx_flag);
 
 #ifdef __cplusplus
diff --git a/lib/mbuf/version.map b/lib/mbuf/version.map
index 940b04096520..b63e28a8cc4d 100644
--- a/lib/mbuf/version.map
+++ b/lib/mbuf/version.map
@@ -16,6 +16,15 @@ DPDK_22 {
 	rte_get_tx_ol_flag_list;
 	rte_get_tx_ol_flag_name;
 	rte_mbuf_best_mempool_ops;
+	rte_mbuf_dyn_dump;
+	rte_mbuf_dyn_rx_timestamp_register;
+	rte_mbuf_dyn_tx_timestamp_register;
+	rte_mbuf_dynfield_lookup;
+	rte_mbuf_dynfield_register;
+	rte_mbuf_dynfield_register_offset;
+	rte_mbuf_dynflag_lookup;
+	rte_mbuf_dynflag_register;
+	rte_mbuf_dynflag_register_bitnum;
 	rte_mbuf_platform_mempool_ops;
 	rte_mbuf_sanity_check;
 	rte_mbuf_set_platform_mempool_ops;
@@ -37,15 +46,6 @@ EXPERIMENTAL {
 	global:
 
 	rte_mbuf_check;
-	rte_mbuf_dynfield_lookup;
-	rte_mbuf_dynfield_register;
-	rte_mbuf_dynfield_register_offset;
-	rte_mbuf_dynflag_lookup;
-	rte_mbuf_dynflag_register;
-	rte_mbuf_dynflag_register_bitnum;
-	rte_mbuf_dyn_dump;
-	rte_mbuf_dyn_rx_timestamp_register;
-	rte_mbuf_dyn_tx_timestamp_register;
 	rte_pktmbuf_pool_create_extbuf;
 
 };